/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include "include/gnotify.h"

int timeouthdl;
GtkWidget *frmNotify;

int gnotify_notify(int cid)
{
  GtkWidget *tabNotify;
  GtkWidget *imgNotify;
  GtkWidget *lblNotify;
  GtkWidget *lblApp;
  GtkWidget *cmdButton;
	GtkWidget *fraNotify;
  char buff[1024];
  pthread_t soundplay;
  
  if(pthread_mutex_lock(&mutex)==0)
  {
  	/* Switching into GTK-Mode */
	  gtk_set_locale ();
  	gtk_init (NULL,NULL);
	
  	frmNotify=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  	g_signal_connect(GTK_OBJECT(frmNotify), "destroy",G_CALLBACK(gtk_main_quit),NULL);
  	gtk_window_set_title(GTK_WINDOW(frmNotify),"GNotify");
  	gtk_window_set_default_size(GTK_WINDOW(frmNotify),10,10);
		if((cfg.notify_allowmove==1)&&(cdb[cid].move_x>-1)&&(cdb[cid].move_y>-1))
		{
			gtk_window_move(GTK_WINDOW(frmNotify),cdb[cid].move_x,cdb[cid].move_y);
		}
		else
		{
	  	gtk_window_move(GTK_WINDOW(frmNotify),cfg.notify_x,cfg.notify_y);
		}			
  	gtk_window_set_decorated(GTK_WINDOW(frmNotify), FALSE);
  	gtk_window_set_skip_taskbar_hint(GTK_WINDOW(frmNotify),TRUE);
  	gtk_window_set_skip_pager_hint(GTK_WINDOW(frmNotify),TRUE);
  	gtk_window_stick(GTK_WINDOW(frmNotify));
  	
  	tabNotify=gtk_table_new(3,2,FALSE);
  	
  	lblApp=gtk_label_new(NULL);
  	sprintf(buff,"<b>%s</b>",cdb[cid].app);
  	gtk_label_set_markup(GTK_LABEL(lblApp),buff);
  	lblNotify=gtk_label_new(NULL);
  	sprintf(buff,"<i>%s</i>",cdb[cid].msg);
  	gtk_label_set_markup(GTK_LABEL(lblNotify),buff);
		
		fraNotify=gtk_frame_new(NULL);
		gtk_frame_set_shadow_type(GTK_FRAME(fraNotify),GTK_SHADOW_OUT);
		
		gtk_container_set_border_width(GTK_CONTAINER(fraNotify),0);
  
  	gtk_container_set_border_width(GTK_CONTAINER(frmNotify),0);
		if(strncmp(cdb[cid].icon,"<NULL>",5)!=0)  
		{
  		imgNotify=gtk_image_new_from_file(cdb[cid].icon);
  		gtk_table_attach(GTK_TABLE(tabNotify),imgNotify,0,1,0,2,GTK_FILL,GTK_FILL,6,6);
		}
  	gtk_table_attach(GTK_TABLE(tabNotify),lblApp,1,2,0,1,GTK_FILL,GTK_FILL,6,0);
  	gtk_table_attach(GTK_TABLE(tabNotify),lblNotify,1,2,1,2,GTK_FILL,GTK_FILL,6,6);
  	if(strncmp(cdb[cid].button,"<NULL>",5)!=0)
  	{
		  cmdButton=gtk_button_new_with_label(cdb[cid].button);
		  g_signal_connect(G_OBJECT(cmdButton),"clicked",G_CALLBACK(buttonclick),(int *)cid);
		  gtk_table_attach(GTK_TABLE(tabNotify),cmdButton,2,3,1,2,GTK_FILL,GTK_FILL,6,0);
		}
		
  	gtk_container_add(GTK_CONTAINER(fraNotify),tabNotify);
		gtk_container_add(GTK_CONTAINER(frmNotify),fraNotify);
		
  	gtk_widget_show_all(frmNotify);
  	timeouthdl=gtk_timeout_add(cfg.notify_delay,(GtkFunction)gnotify_notify_quit,NULL);
		if(((strcmp(cdb[cid].snd,"")!=0)||(strcmp(cdb[cid].snd,"<NULL>")!=0))&&(cfg.notify_play==1))
		{
		 	if(pthread_create(&soundplay,NULL,(void *)&playsound,(void *)cdb[cid].snd)!=0)
		  {
				g_printerr("couldn't play sound, cause: failed to create sound-thread!\n");
		  }
		}
  	gtk_main();
  }
  else
  {
    g_printerr("couldn't lock mutex!\n");
    exit(-1);
  }
  if(pthread_mutex_unlock(&mutex)!=0)
  {
    g_printerr("couldn't release mutex from thread %ld!\n",pthread_self());
    exit(-1);
  }
	if(cfg.notify_forkgtk==0)
	  return(0);
	else if(cfg.notify_forkgtk==1)
		exit(0);
	else if(cfg.notify_forkgtk==2)
		pthread_exit((void*)0);
	else /* lol? */
		return(0);
}

static void gnotify_notify_quit(GtkWidget *widget,gpointer data)
{
	gtk_widget_destroy(frmNotify);
	gtk_main_quit();
}

static void buttonclick(GtkWidget *widget,gpointer data)
{
 	send(cdb[(int)data].sockfd,"221 Button pressed\n",20,0);
	gtk_timeout_remove(timeouthdl);
	gtk_object_destroy((GtkObject*)(frmNotify));
	return;
}

void gnotify_about(void)
{
	GtkWidget *frmAbout;
  GtkWidget *tabAbout;
  GtkWidget *imgAbout;
  GtkWidget *lblAbout;
  GtkWidget *lblAbout2;
  GtkWidget *cmdClose;
	char abouttbuff[32];
	char aboutbuff[512];
  
  gtk_set_locale ();
 	gtk_init (NULL,NULL);
	
 	frmAbout=gtk_window_new(GTK_WINDOW_TOPLEVEL);
 	g_signal_connect_swapped(GTK_OBJECT(frmAbout), "destroy",G_CALLBACK(gtk_main_quit),NULL);
 	gtk_window_set_title(GTK_WINDOW(frmAbout),"About GNotify");
 	gtk_window_set_default_size(GTK_WINDOW(frmAbout),100,150);
  	
 	tabAbout=gtk_table_new(3,3,FALSE);
  	
 	lblAbout=gtk_label_new(NULL);
 	sprintf(abouttbuff,"\n<span size=\"xx-large\" weight=\"bold\">GNotify %s</span>\n\n",VERSION);
 	gtk_label_set_markup(GTK_LABEL(lblAbout),abouttbuff);
 	lblAbout2=gtk_label_new(NULL);
 	sprintf(aboutbuff,"GNotify %s\nby DevilX [devilx@users.sourceforge.net], Copyright (c) 2004\n\nhttp://gnotify.sourceforge.net\n\nThis program is free software; you can redistribute it and/or modify\nit under the terms of the GNU General Public License as published by\nthe Free Software Foundation; either version 2 of the License, or\n(at your option) any later version.\n\n",VERSION);
 	gtk_label_set_markup(GTK_LABEL(lblAbout2),aboutbuff);
		
	imgAbout=gtk_image_new_from_file(GNOTIFY_ICON);
	
	cmdClose=gtk_button_new_with_label("Close");
	g_signal_connect_swapped(GTK_OBJECT(cmdClose), "clicked",G_CALLBACK(gtk_main_quit),NULL);

	gtk_table_attach(GTK_TABLE(tabAbout),imgAbout,0,1,0,1,GTK_FILL,GTK_FILL,6,6);
	gtk_table_attach(GTK_TABLE(tabAbout),lblAbout,1,3,0,1,GTK_FILL|GTK_EXPAND,GTK_FILL,6,6);
 	gtk_table_attach(GTK_TABLE(tabAbout),lblAbout2,1,3,1,2,GTK_EXPAND,GTK_EXPAND,6,6);
 	gtk_table_attach(GTK_TABLE(tabAbout),cmdClose,2,3,2,3,GTK_FILL,GTK_FILL,6,6);
		
  gtk_container_add(GTK_CONTAINER(frmAbout),tabAbout);
		
  gtk_widget_show_all(frmAbout);
  gtk_main();
	exit(0);
}
